﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;   //必须添加，不然DllImport报错
using System.Threading;
namespace di_continuous
{
    class Program
    {
        static void Main(string[] args)
        {
            int temp;
	        int i;
	        int DevIndex = 0;		// 设备索引，默认设备 0
	        byte[] Di= new byte[80000];
	
	        // 调用函数时，返回错误代码
	        // 打开设备
	        temp = USB3000DLL.USB3OpenDevice(DevIndex);

            //返回值以及代表SN码 以及型号信息
            temp = USB3000DLL.USB3ReadDevcieSN(DevIndex);
            Console.WriteLine("SN码：" + temp);
            temp = USB3000DLL.USB3ReadDevcieModel(DevIndex);
            Console.WriteLine("型号为USB-" + temp);
	
	        // 设置 Conv Out 端口输出信号源为数字输入采样时钟。如果不使用该信号，可不设置。
	        temp = USB3000DLL.SetUSB3ExtConvOutSource(DevIndex, 3);
	
	        // 设置 Ext Trig Out 端口输出信号源为数字输入触发信号。如果不使用该信号，可不设置。
	        temp = USB3000DLL.SetUSB3ExtTrigOutSource(DevIndex, 1);

	        // 设置为连续采集模式
	        temp = USB3000DLL.SetUSB3DiSampleMode(DevIndex, 0);

	        // 设置模拟输入采集使用 DiSoftTrig 软件触发
	        temp = USB3000DLL.SetUSB3DiTrigSource(DevIndex, 0);

	        // 设置模拟输入采样时钟源为 Di 内部采样时钟源。该时钟源频率由 SetUSB3DiSampleRate() 函数设定。
	        temp = USB3000DLL.SetUSB3DiConvSource(DevIndex, 0);

	        // 设置采样周期为 100000ns，即 10kSa/s/Ch 换算关系 f = 1/ T
	        temp = USB3000DLL.SetUSB3DiSampleRate(DevIndex, 100000);

	        // 设置 Di 预触发点数为 0
	        temp = USB3000DLL.SetUSB3DiPreTrigPoints(DevIndex, 0);

	        // 清空 DiFifo
	        temp = USB3000DLL.SetUSB3ClrDiFifo(DevIndex);

	        // 启动 DiSoftTrig 软件触发
	        temp = USB3000DLL.SetUSB3DiSoftTrig(DevIndex);

	        // 开始读取数据。
	        // 如果需要长时间连续采集，持续循环使用 USB3GetDi() 函数读取即可。
	        // 读取出来的数据是稳定连续采集得到的数据。
	        // 此处作为范例，仅连续读取 10 次。
            // GetDi函数返回值代表缓冲区剩余数据个数 通道缓冲区数据空间的是2百万个数据空间
	        for(i = 0; i < 10; i++)
	        {   
                //范例以8通道Di为例 默认Di有上拉 默认高电平 默认返回值是255 如果是2通道Di 返回值是3
		        // 每通道读取 10000 个点存放于 Di 数组中，超时时间为 1000ms
		        // 每一个 Di 数据的 bit-0 代表 Di 0 通道；
		        //                  bit-1 代表 Di 1 通道。
		        temp = USB3000DLL.USB3GetDi(DevIndex, 1000, Di, 1000);
                Console.WriteLine("缓冲区剩余数据个数："+ temp);
                Console.WriteLine( "Di数据"+ Di[0]);
	        }

	        // 清除 Di 触发信号
	        temp = USB3000DLL.SetUSB3ClrDiTrigger(DevIndex);
	        // 清空 AiFifo
	        temp = USB3000DLL.SetUSB3ClrDiFifo(DevIndex);
	        // 关闭设备
	        temp = USB3000DLL.USB3CloseDevice(DevIndex);
            /*如需了解更多函数参数意义，则需要访问smmacq.cn对应产品系列函数手册进行查询
            *以及了解各类函数返回值负数代表的错误意义            
            */
         }
    }
    class USB3000DLL
    {
        [DllImport("USB3000.dll")]
        public static extern int FindUSB3DAQ();
        [DllImport("USB3000.dll")]
        public static extern int USB3OpenDevice(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int USB3CloseDevice(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int USB3ReadDevcieSN(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int USB3ReadDevcieModel(int DevIndex);

        //--------------------------------------------------------------------------
        // Ananlog Input Configuration

        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiSampleRate(int DevIndex, uint SamplePeriod);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiSampleMode(int DevIndex, byte AiSampleMode);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiConnectType(int DevIndex, byte AiConnectType);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiRange(int DevIndex, byte Chan, float AiRange);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiChanSel(int DevIndex, byte Chan, byte Sel);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiTrigSource(int DevIndex, byte AiTrigSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiConvSource(int DevIndex, byte AiConvSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiPreTrigPoints(int DevIndex, uint AiPreTrigPoints);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiOneShotPoints(int DevIndex, uint AiOneShotPoints);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrAiFifo(int DevIndex);

        //--------------------------------------------------------------------------
        // Digital I/O Configuration

        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DiSampleRate(int DevIndex, uint SamplePeriod);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DiSampleMode(int DevIndex, byte DiSampleMode);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DiTrigSource(int DevIndex, byte DiTrigSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DiConvSource(int DevIndex, byte DiConvSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DiPreTrigPoints(int DevIndex, uint DiPreTrigPoints);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DiOneShotPoints(int DevIndex, uint DiOneShotPoints);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrDiFifo(int DevIndex);

        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoSampleRate(int DevIndex, uint SamplePeriod);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoSampleMode(int DevIndex, byte DoSampleMode);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoTrigSource(int DevIndex, byte DoTrigSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoConvSource(int DevIndex, byte DoConvSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoCycle(int DevIndex, uint DoCycle);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoDataFifo(int DevIndex, uint[] Value, uint Len);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrDoFifo(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoWaveCtrl(int DevIndex, uint Chan);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoImmediately(int DevIndex, uint Chan, uint Value);

        //--------------------------------------------------------------------------
        // Ananlog Output Configuration

        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoSampleRate(int DevIndex, byte Chan, uint SamplePeriod);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoSampleMode(int DevIndex, byte Chan, byte AoSampleMode);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoTrigSource(int DevIndex, byte Chan, byte AoTrigSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoConvSource(int DevIndex, byte Chan, byte AoConvSource);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoCycle(int DevIndex, byte Chan, byte AoCycle);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoDataFifo(int DevIndex, byte Chan, float[] Voltage, uint Len);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrAoFifo(int DevIndex, byte Chan);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoSync(int DevIndex, byte Chans);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoImmediately(int DevIndex, byte Chan, float Voltage);

        //--------------------------------------------------------------------------
        // Trig Control

        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AiSoftTrig(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DiSoftTrig(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3DoSoftTrig(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3AoSoftTrig(int DevIndex, byte Chan);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3GlobalSoftTrig(int DevIndex);

        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrTrigger(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrAiTrigger(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrDiTrigger(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrDoTrigger(int DevIndex);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrAoTrigger(int DevIndex, byte Chan);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ClrGlobalSoftTrig(int DevIndex);

        //--------------------------------------------------------------------------
        // Sync Configuration

        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ExtTrigOutSource(int DevIndex, byte Source);
        [DllImport("USB3000.dll")]
        public static extern int SetUSB3ExtConvOutSource(int DevIndex, byte Source);

        //--------------------------------------------------------------------------
        // Get Data Acquired

        [DllImport("USB3000.dll")]
        public static extern int USB3GetAi(int DevIndex, uint Points, float[] Ai, int TimeOut);
        [DllImport("USB3000.dll")]
        public static extern int USB3GetDi(int DevIndex, uint Points, byte[] Di, int TimeOut);
    }
}
